'use strict';

const _ = require('lodash');
const Structure = require('./structure');
const util = require('../util');

module.exports = class Transform extends Structure {

  getData (key) {
    var self = this;
    if (!key) {
      return _.extend({}, self);
    }
    return _.extend({}, self._get(key));
  }

  clone (key) {
    var self = this;
    if (!key) return _.child();
    return self.get(key).child();
  }

  toArray (key, name = '_name') {
    var self = this,
      val = key ? self.get(key) : self;
    if (typeof val !== 'object') {
      return null;
    }
    return util.objectsToArray(val, name);
  }

}
